/* Sistemas Integrados TEKNISA

Nome: 520D_DFSSTPS_GERA_NOTAFISCAL_ENCARGO.SQL

Descrio:
PROCEDIMENTOS PARA GERAO DE NOTAS FISCAIS ENCARGO

Criao:
05/10/2005 - Fabrcio Marcelo da Silva
*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'GERA_NOTAFISCAL_ENCARGO' AND
	           TYPE = 'P' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

DROP PROCEDURE GERA_NOTAFISCAL_ENCARGO
GO

CREATE PROCEDURE GERA_NOTAFISCAL_ENCARGO
   @P_CDFILIAL       VARCHAR(04),
   @P_NRLANCTONF     VARCHAR(10),
   @P_CDENCARGO      VARCHAR(02),
   @P_VRITEMENCA     DOUBLE PRECISION
AS
   DECLARE @V_EXISTE_ENCARGO NUMERIC;
BEGIN
   SET @V_EXISTE_ENCARGO = 0;

   SELECT @V_EXISTE_ENCARGO = COUNT(*)
   FROM   ITEMENCARGO
   WHERE  CDFILIAL   = @P_CDFILIAL
     AND  NRLANCTONF = @P_NRLANCTONF
     AND  CDENCARGO  = @P_CDENCARGO;
   IF @V_EXISTE_ENCARGO = 0 BEGIN
      INSERT INTO ITEMENCARGO
         (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
      VALUES
         (@P_CDFILIAL, @P_NRLANCTONF, @P_CDENCARGO, @P_VRITEMENCA);
   END
   ELSE BEGIN
      UPDATE ITEMENCARGO
      SET    VRITEMENCA = VRITEMENCA +    @P_VRITEMENCA
      WHERE  CDFILIAL   = @P_CDFILIAL
        AND  NRLANCTONF = @P_NRLANCTONF
        AND  CDENCARGO  = @P_CDENCARGO;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_NOTAFISCAL_ENCARGO','6.10.000';
GO

