<?php
namespace tests\Zeedhi\Tools\EntityGenerators;

use Doctrine\ORM\EntityManager;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Zeedhi\Model\Util\Environment;
use Zeedhi\Tools\EntityGenerator\DefaultInflector;
use Zeedhi\Tools\EntityGenerator\Metadata;
use Zeedhi\Tools\EntityGenerator\Inflector;

class MetadataGeneratorTest extends \PHPUnit_Framework_TestCase {

    /** @var Metadata */
    protected $metadataGenerator;
    protected $tableImporter;
    protected $metaData;
    protected $data;
    protected $entities;

    protected function setUp() {
        $tablesToImportConnection = \Doctrine\DBAL\DriverManager::getConnection(array(
            'driver'    => 'oci8',
            'user'      => 'USR_ORG_20',
            'password'  => 'teknisa',
            'host'      => '192.168.122.5',
            'port'      => '1521',
            'dbname'    => 'pdborcl',
            'service'   => true
        ));
        $databaseReader = DatabaseReader::factoryFromConnection($tablesToImportConnection);
        
        $this->entities = json_decode(file_get_contents(__DIR__."/../../../mocks/entities.json"), true);
      
        $this->tableImporter = new TableImporter($databaseReader);
        $this->tableImporter->importTablesWithSubModel($entities["subModelsByTables"]);
        $this->data = $this->tableImporter->getData();
        
        $this->metadataGenerator = new Metadata(new Inflector());
    }

    public function testGenerateAllEntitiesMetadata() {
        $entitiesNames = $this->metadataGenerator->generateEntitiesForTableNames($this->tableNames, $this->entities["namespace"], $this->entities["subModelsByTables"]);
        $this->assertCount(2, $entitiesNames);
    }

}